/* komun.c
   
	 Komunikacia na baze IPX protokolu
	 autor: Robert Trebula
	 kruzok: SI 4
	 rok: 2000
*/

#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <conio.h>
#include "ipx.h"
#include "p.h"

//#define DEBUG

Name myName;
Name *unique=&myName;
Name *group=NULL;

#define ASKNAME 1
#define TESTNAME 2
#define WORK 3
int stage=ASKNAME;

main ()
{
	int ret;
	int i;
	P_packet packet;
	P_packet *pp;
	BYTE *bp;
	char *cp;
	BYTE ma[10];
	char buff[256];
	ECB ListenEcbs[10];
	time_t t;

	clrscr();randomize();

	InitIPX();

	IPXGetInternetworkAddress(ma);
	memcpy(myName.a,ma+4,6);
	myName.next=NULL;

	printf("IPX communicator (c) Robert Trebula\n");
	printf("Listening on machine %s, socket %d that is 0x%x in IPX.\n",formatAddr(ma+4),MYSOCKET, htonl(MYSOCKET));

	for(i=0;i<10;i++) {
		InitListenEcb(ListenEcbs+i);
	}

	while(1) {
		if(stage==TESTNAME) {
			if(time(NULL)-t>2) {
				printf("Testing of name succeeded.\n");
				pp=malloc(sizeof(P_packet));
				strncpy(pp->ph.source,myName.c,10);
				strncpy(pp->body,myName.c,10);
				pp->ph.type=SETUNIQUENAME;
				SendPacket(BROADCAST,pp);
				free(pp);
				stage=WORK;
			}
		}
		if(stage==ASKNAME) {
			printf("Your unique name: ");
			scanf("%10s",myName.c);
			stage=TESTNAME;
			t=time(NULL);
			pp=malloc(sizeof(P_packet));
			strncpy(pp->body,myName.c,10);
			pp->ph.type=UNIQUE;
			SendPacket(BROADCAST,pp);
			free(pp);
		}
		for(i=0;i<10;i++) {
			pp=CheckListenEcb(ListenEcbs+i);
			if(pp) {
				ParsePacket(pp);
				free(pp);
			}
		}
		if(stage==WORK) {
			if(kbhit()) {
				fflush(stdin);
				UserInput();
			}
		}
	}
}

int InitListenEcb(ECB *ecb)
{
	int ret;
	P_packet *packet;

	packet=malloc(sizeof(P_packet));
	if(!packet) {
		printf("InitListenEcb():Memory allocation failure.\n");
		exit(-1);
	}

	memset(ecb,0, sizeof(ECB));
	memset(packet,0, sizeof(P_packet));

	ecb->socketNumber=htonl(MYSOCKET);
	memset(ecb->immediateAddress,0xff,6);
	ecb->fragmentCount=1;
	ecb->fragmentDescriptor[0].address=packet;
	ecb->fragmentDescriptor[0].size=sizeof(P_packet);

	IPXListenForPacket(ecb);

	return(0);
}

P_packet *CheckListenEcb(ECB *ecb)
{
	P_packet *p;
	switch(ecb->inUseFlag) {
		case 0xfe:
			return((P_packet *)NULL);
		case 0x00:
			p=(P_packet *)ecb->fragmentDescriptor[0].address;
			if(ecb->completionCode) {
				printf("Received a packet, but completionCode is 0x%x. Bad.\n", ecb->completionCode);
				exit(1);
			}
#ifdef DEBUG
			printf("We've got a packet.\n");
#endif DEBUG
			InitListenEcb(ecb);
			return (p);
		default:
#ifdef DEBUG
			printf("CheckListenPacket(): ecb returned %x. Wrong.\n", ecb->inUseFlag);
#endif DEBUG
			free((P_packet *)ecb->fragmentDescriptor[0].address);
			InitListenEcb(ecb);
			return((P_packet *)NULL);
	}
}

int ParsePacket(P_packet *pp)
{
	P_packet *packet;
	char buff[256];
	switch(pp->ph.type) {
		case DATA:
			if(isMyName(pp->ph.destination)) {
				strncpy(buff,pp->ph.source,10);
				printf("Message from:%s ",buff);
				strncpy(buff,pp->ph.destination,10);
				printf("to:%s\n",buff);
				if(pp->ph.length) {
						strncpy(buff,pp->body,pp->ph.length+1);
						printf("%s(%d bytes)\n",buff,pp->ph.length);
				} else printf("0 bytes\n");
			}
			break;
		case SETUNIQUENAME:
			if(stage==WORK) {
				addName(unique,pp->body,pp->ipxh.source.node);
			}
			break;
		case ADDGROUPNAME:
			addName(group,pp->body,pp->ipxh.source.node);
			break;
		case DELETENAME:
			if(stage==WORK) {
				if(deleteName(group,pp->body,pp->ipxh.source.node))
					deleteName(unique,pp->body,pp->ipxh.source.node);
			}
			break;
		case UNIQUE:
			if(stage==WORK || stage==TESTNAME) {
        if(memcmp(myName.a,pp->ipxh.source.node,6)) {
          if(strncmp(myName.c,pp->body,10))
				   	delay(500+random(1500));  //500-2000 ms
          packet=malloc(sizeof(P_packet));
   				memcpy(packet->body,myName.c,10);
  				packet->ph.type=RESPONSE;
#ifdef DEBUG
	  			printf("Sending RESPONSE to %s.\n",formatAddr(pp->ipxh.source.node));
#endif DEBUG
		  		SendPacket(pp->ipxh.source.node,packet);
			  	free(packet);
        }
      }
			break;
		case RESPONSE:
			if(stage==TESTNAME) {
				if(!strncmp(myName.c,pp->body,10)) stage=ASKNAME;
        else addName(unique,pp->body,pp->ipxh.source.node);
			}
			break;
		case DELETENODE:
			if(stage==WORK) {
				DeleteNode(pp->ipxh.source.node);
			}
			break;
		default:
#ifdef DEBUG
			printf("Unknown type: %d\n",pp->ph.type);
			printf("From: %s, To: %s\n",pp->ph.source,pp->ph.destination);
#endif DEBUG
			break;
	}
	return(0);
}

int SendPacket(BYTE *dest, P_packet *packet)
{
	ECB *ecb;
	int ret;

	ecb=malloc(sizeof(ECB));
	if(!ecb) {
		printf("SendPacket():Memory allocation failure. Exiting.\n");
		exit(-1);
	}
	memset(ecb,0, sizeof(ECB));
	packet->ipxh.checkSum=0xffff;
	packet->ipxh.transportControl=0;
	packet->ipxh.packetType=0;
	memset(packet->ipxh.destination.network,0,4);
	memcpy(packet->ipxh.destination.node,dest,6);
	packet->ipxh.destination.socket=htonl(MYSOCKET);
	ecb->socketNumber=htonl(MYSOCKET);
	memcpy(ecb->immediateAddress,dest,6);
	ecb->fragmentCount=1;
	ecb->fragmentDescriptor[0].address=packet;
	ecb->fragmentDescriptor[0].size=sizeof(P_packet);
	IPXSendPacket(ecb);
	while(ecb->inUseFlag!=0);
	ret= ecb->completionCode;
	free(ecb);
	return ret;
}

BYTE *GetHostByName(char *name)
{
	Name *n;
	n=unique;
	while(n) {
		if(!strncmp(n->c,name,10)) return(n->a);
		n=n->next;
	}
	n=group;
	while(n) {
		if(!strncmp(n->c,name,10)) return(BROADCAST);
		n=n->next;
	}
	return(NULL);
}

int UserInput(void)
{
	int ret;
	Name *n;
	P_packet *pp;
	char buff[255];

	printf("1.Message\n");
	printf("2.List known names\n");
	printf("3.Add group name\n");
	printf("4.Delete droup name\n");
	printf("0.Exit\n");
	scanf("%d",&ret);
	switch (ret) {
		case 1:
			SendData();
			break;
		case 2:
			n=unique;
			do {
				printf("%s:%s (UNIQUE)\n",formatAddr(n->a),n->c);
				n=n->next;
			} while(n);
			n=group;
			while(n) {
				printf("%s:%s (GROUP)\n",formatAddr(n->a),n->c);
				n=n->next;
			}
			break;
		case 3:
			printf("Group name: ");
			scanf("%10s",buff);
			pp=malloc(sizeof(P_packet));
			strncpy(pp->ph.source,myName.c,10);
			strncpy(pp->body,buff,10);
			pp->ph.type=ADDGROUPNAME;
			SendPacket(BROADCAST,pp);
			free(pp);
			break;
		case 4:
			printf("Group name: ");
			scanf("%10s",buff);
			if(isMyName(buff)) {
				pp=malloc(sizeof(P_packet));
				strncpy(pp->ph.source,myName.c,10);
				strncpy(pp->body,buff,10);
				pp->ph.type=DELETENAME;
				SendPacket(BROADCAST,pp);
				free(pp);
			} else {
				printf("%s is not your group name.\n");
			}
			break;
		case 0:
			pp=malloc(sizeof(P_packet));
			pp->ph.type=DELETENODE;
			strncpy(pp->ph.source,myName.c,10);
			SendPacket(BROADCAST,pp);
			free(pp);
			IPXCloseSocket(htonl(MYSOCKET));
			exit(0);
		default:
			printf("Unknown command: %d\n", ret);
	}
	return(0);
}

int SendData(void)
{
	BYTE *bp;
	P_packet *pp;
	char buff[256];
	int ret;

	pp=malloc(sizeof(P_packet));
	memset(pp,0,sizeof(P_packet));
	printf("Message to: ");
	scanf("%10s",buff);
	bp=GetHostByName(buff);
	if(!bp) {
		printf("Unknown host: %s\n",buff);
		goto SENT;
	}
	strncpy(pp->ph.destination,buff,10);
#ifdef DEBUG
	printf("Message from: ");
	scanf("%10s",buff);
	strncpy(pp->ph.source,buff,10);
	printf("Type: ");
	scanf("%d",&ret);
	if(ret<0 || ret>6) {
		printf("Wrong type: %d\n",ret);
		goto SENT;
	}
#else
	ret=4;
	strncpy(pp->ph.source,myName.c,10);
#endif DEBUG
	pp->ph.type=(BYTE)ret;
	printf("Message: ");
	fflush(stdin);
	fgets(buff,255,stdin);
	strncpy(pp->body,buff,255);
	pp->ph.length=strlen(buff);
	SendPacket(bp,pp);
	printf("Message sent successfully.\n");

	SENT:
	free(pp);
	return(0);
}

int addName(Name *where, char *name, BYTE *addr)
{
	Name *p=where;

	//XXX: this is a very ugly hack
	if(!where) {
		p=malloc(sizeof(Name));
		memcpy(p->c,name,10);
		memcpy(p->a,addr,6);
		p->next=NULL;
		group=p;
#ifdef DEBUG
		printf("Adding name %s, %s\n",name,formatAddr(addr));
#endif DEBUG
		return(0);
	}

	while(p->next) {
		if(!strncmp(p->c,name,10)&&!memcmp(p->a,addr,6)) return(0);
		p=p->next;
	}
	if(!strncmp(p->c,name,10) && !memcmp(p->a,addr,6)) return(0);
#ifdef DEBUG
	printf("Adding name %s, %s\n",name,formatAddr(addr));
#endif DEBUG
	p->next=malloc(sizeof(Name));
	memcpy(p->next->c,name,10);
	memcpy(p->next->a,addr,6);
	p->next->next=NULL;
	return(0);
}

int deleteName(Name *where, char *name, BYTE *addr)
{
	int r=1;
	Name *p=where,*prev=NULL;
	if(!where) return(1);
	do {
		if(!strncmp(name,p->c,10) && !memcmp(addr,p->a,6)) {
			if(prev) prev->next=p->next;
			else group=p->next; //XXX: this sucks
#ifdef DEBUG
			printf("Deleting name %s of %s.\n",p->c,formatAddr(p->a));
#endif DEBUG
			free(p);
			r=0;
		} else prev=p;
		p=p->next;
	}while(p);
	return(r);
}

int DeleteNode(BYTE *addr)
{
	Name *p=unique,*prev=NULL;
	do {
		if(!memcmp(addr,p->a,6)) {
#ifdef DEBUG
			printf("DeleteNode: deleting %s: %s (UNIQUE)\n",formatAddr(addr),p->c);
#endif DEBUG
			prev->next=p->next;
			free(p);
		} else prev=p;
		p=p->next;
	} while(p);
	p=group;prev=NULL;
	while(p) {
		if(!memcmp(addr,p->a,6)) {
#ifdef DEBUG
			printf("DeleteNode: deleting %s: %s (GROUP)\n",formatAddr(addr),p->c);
#endif DEBUG
			if(prev) prev->next=p->next;
			else group=p->next;
			free(p);
		}else prev=p;
		p=p->next;
	}
	return(0);
}

int InitIPX(void)
{
	int ret;

	ret=IPXInitialize();
	if(ret) {
		printf("Cannot initialize IPX. Bad.\n"); exit(-1);
	}

	ret=IPXOpenSocket(htonl(MYSOCKET));
	if(ret) {
		ret=IPXCloseSocket(htonl(MYSOCKET));
		if(ret) {
			printf("Cannot open socket. Bad.\n"); exit(1);
		}
		ret=IPXOpenSocket(htonl(MYSOCKET));
		if(ret) {
			printf("Cannot open socket. Bad\n"); exit(1);
		}
	}
	return(0);
}

int isMyName(char *n)
{
	Name *p=group;
	if(!strncmp(n,myName.c,10)) return(1);
	while(p) {
		if(!strncmp(n,p->c,10) && !memcmp(myName.a,p->a,6)) return(1);
		p=p->next;
	}
	return(0);
}
